//+------------------------------------------------------------------+
//|                                             MarketOrdersOHLC.mq5 |
//|                                                      nicholishen |
//|                                                         nick.com |
//+------------------------------------------------------------------+
//--- input parameters


input bool     inp_load_tick_data = false;
input int      inp_len_ma = 20;

#include "NetVolumizer2.mqh"

input int inp_num_days = 15; //Number of days lookback

#define UP_COL  1
#define DN_COL  0

Volumizer g_volumizer;

//--- indicator buffers
//double         _MOMA_Buffer[];
double         _VOL_CANDLES_Buffer1[];
double         _VOL_CANDLES_Buffer2[];
double         _VOL_CANDLES_Buffer3[];
double         _VOL_CANDLES_Buffer4[];
double         _VOL_CANDLES_Colors[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
{
   SetIndexBuffer(0, _VOL_CANDLES_Buffer1, INDICATOR_DATA);
   SetIndexBuffer(1, _VOL_CANDLES_Buffer2, INDICATOR_DATA);
   SetIndexBuffer(2, _VOL_CANDLES_Buffer3, INDICATOR_DATA);
   SetIndexBuffer(3, _VOL_CANDLES_Buffer4, INDICATOR_DATA);
   SetIndexBuffer(4, _VOL_CANDLES_Colors, INDICATOR_COLOR_INDEX);
   ArrayInitialize(_VOL_CANDLES_Buffer1, 0.0);
   ArrayInitialize(_VOL_CANDLES_Buffer2, 0.0);
   ArrayInitialize(_VOL_CANDLES_Buffer3, 0.0);
   ArrayInitialize(_VOL_CANDLES_Buffer4, 0.0);
   PlotIndexSetDouble(0, PLOT_EMPTY_VALUE, 0.0);
   PlotIndexSetInteger(0,PLOT_LINE_COLOR,0,clrRed);
   PlotIndexSetInteger(0,PLOT_LINE_COLOR,1,clrLimeGreen);
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
//---
   CHashMap<datetime, VolBar*> *map = NULL;
   VolBar *bar = NULL;
   int x = rates_total - 1;
   if (prev_calculated == 0)
   {
      map = g_volumizer.initialize((TimeCurrent() - PeriodSeconds(PERIOD_D1) * inp_num_days) * 1000);
      x = 0;
      ArrayInitialize(_VOL_CANDLES_Buffer1, EMPTY_VALUE);
      ArrayInitialize(_VOL_CANDLES_Buffer2, EMPTY_VALUE);
      ArrayInitialize(_VOL_CANDLES_Buffer3, EMPTY_VALUE);
      ArrayInitialize(_VOL_CANDLES_Buffer4, EMPTY_VALUE);
   }
   map = g_volumizer.refresh();
   for (int i=x; i<rates_total; i++)
   {
      if (map.TryGetValue(time[i], bar) && CheckPointer(bar))
      {
         _VOL_CANDLES_Buffer1[i] = bar.bar.open;
         _VOL_CANDLES_Buffer2[i] = bar.bar.high;
         _VOL_CANDLES_Buffer3[i] = bar.bar.low;
         _VOL_CANDLES_Buffer4[i] = bar.bar.close;
         _VOL_CANDLES_Colors[i] = bar.bar.open > bar.bar.close ? DN_COL : UP_COL;
      }
   }
   return(rates_total);
}
//+------------------------------------------------------------------+
